/*
 * Dine-O-Matic v2.0
 * Copyright 2007 - Iconfactory - http://iconfactory.com
 * 
 * Programmer: Joe Roback <joe.roback@gmail.com>
 * Graphics: Talos Tsui, Corey Marion, David Lanham
 * Audio: Dave Brasgalla
 *
 * --------------------------------------------------------------------
 * TODOs
 * --------------------------------------------------------------------
 * 
 * --------------------------------------------------------------------
 * QUESTIONs
 * --------------------------------------------------------------------
 * 
 * --------------------------------------------------------------------
 * THINGs I WISH I HAD TIME FOR
 * --------------------------------------------------------------------
 *  - Make front slider widget into javascript object
 *  - Make categories/restaurants into javascript object
 * --------------------------------------------------------------------
 */

if (window.widget) {
	widget.onremove = remove;
	widget.onhide = hide;
	widget.onshow = show;
}

// technically constants...
var FRONT_WIDTH = 254;
var FRONT_HEIGHT = 259;

var FRONT_WIDTH_INFO = 254;
var FRONT_HEIGHT_INFO = 332;

var BACK_WIDTH = 254;
var BACK_HEIGHT = 485;

var flipWidth = -1;
var flipHeight = -1;

var prefsChanged = new Object;
prefsChanged['sound'] = false;
prefsChanged['favorHigherRated'] = false;
prefsChanged['categories'] = false;
prefsChanged['restaurants'] = false;
prefsChanged['resetIcon'] = false;

var sliderPrefix = null;

/* diner HTML elements by ID, set in initDineomatic() */
var icon = null;
var dinnerPlate = null;

var tabView = null;

var restaurantBar = null;
var restaurantInfo = null;
var restaurantInfoMapLink = null;
var restaurantInfoWebLink = null;
var restaurantInfoAddress = null;
var restaurantInfoTelLabel = null;
var restaurantInfoTel = null;
var restaurantInfoFaxLabel = null;
var restaurantInfoFax = null;
var restaurantInfoRatingLabel = null;
var restaurantInfoRating = null;

var categoryListView = null;
var categoryNameField = null;
var categoryPlusButton = null;
var categoryMinusButton = null;

var restaurantFavorHigherRated = null;
var restaurantListView = null;
var restaurantPlusButton = null;
var restaurantMinusButton = null;
var restaurantInfoNameBack = null;
var restaurantInfoAddressBack = null;
var restaurantInfoTelBack = null;
var restaurantInfoFaxBack = null;
var restaurantInfoWebBack = null;
var restaurantInfoCategoryBack = null;
var restaurantInfoPriceBack = null;
var restaurantInfoRatingBack = null;
var restaurantInfoNameField = null;
var restaurantInfoAddressField = null;
var restaurantInfoTelField = null;
var restaurantInfoFaxField = null;
var restaurantInfoWebField = null;
var restaurantInfoCategoryField = null;
var restaurantInfoPriceField = null;
var restaurantInfoRatingField = null;
var restaurantEditButton = null;

var REMO = null; // Restaurant Edit Mode Object

var noticebox = null;
var sndButton = null;
var doneButton = null;

/* index randomly choosen eatery */
var randNum = -1;
var restaurantPool = null; // array of restaurants to pick from
var pickedRestaurant = null;

var pickOptions = new Object;
pickOptions['price'] = 1;

/* state variables for diner icon animation */
var animateIndex = 0;
var animateTimer = null;
var vending = false;
var neonPlayCount = 0;

/* shuffleMax iterations + 1 final */
var shuffleCount = 0;
var shuffleMax = 20;
var shuffleFullSpdClicks = 12;

var shuffleExp = 2.92512;
var shuffleExpDelay = 25;
var shuffleFinalDelay = -1;

/* Apple Animator object for fading in restaurant info on front */
var faderAnimator = null;

var defaultRestaurantBarText = 'Click plate to eat out!';
var emptyRestaurantBarText = 'Please add restaurants';
var noPickAvailable = 'No matches found';

/* Localize if we can... */
if (window.getLocalizedString) {
	defaultRestaurantBarText = getLocalizedString(defaultRestaurantBarText);
	emptyRestaurantBarText = getLocalizedString(emptyRestaurantBarText);
	noPickAvailable = getLocalizedString(noPickAvailable);
}

/* favor restaurants with higher rating */
var favorHigherRated = true;

/* sound enabled or not */
var soundEnabled = true;

/* if widget is hidden */
var widgetHidden = false;

// number of categories with null name, used as extra icons
var numDefaultCategories = 23;
var numNullCategories = 7;

/*
 * 0: category name
 * 1: enabled - true/false
 * 2: array of pngs, if more than 1 we animate
 * 3: animation delay in milliseconds
 * 4: default category
 */

var defaultCategories = [
	["American", true, ["American.png", "American2.png"], 1125, true],
	["Asian", true, ["Asian1.png", "Asian2.png"], 1125, true],
	["BBQ", true, ["BBQ1.png", "BBQ2.png"], 1125, true],
	["Breakfast", true, 
		["Breakfast.png", "Breakfast2.png", "Breakfast3.png", 
		 "Breakfast4.png"], 1000, true],
	["Caribbean", true, ["Caribbean.png", "Caribbean2.png"], 1125, true],
	["Chinese", true, ["Chinese.png", "Chinese2.png"], 1125, true],
	["Coffee Shop", true, 
		["Coffee0.png", "Coffee1.png", "Coffee2.png",
		 "Coffee3.png", "Coffee4.png", "Coffee5.png",
		 "Coffee6.png", "Coffee7.png", "Coffee8.png",
		 "Coffee9.png"], 575, true],
	["Deli", true, 
		["Deli1.png", "Deli2.png", "Deli3.png",
	     "Deli4.png", "Deli5.png"], 1000, true],
	["Fast Food", true, ["FastFood.png", "FastFood2.png"], 1125, true],
	["French", true, ["French1.png", "French2.png"], 1125, true],
	["Indian", true, ["Indian.png", "Indian2.png"], 1125, true],
	["Italian", true, ["Italian.png", "Italian2.png"], 1125, true],
	["Mediterranean", true, ["Mediterranean.png", "Mediterranean2.png"], 1125, true],
	["Mexican", true, ["Mexican.png", "Mexican2.png"], 1125, true],
	["Middle Eastern", true, 
		["MiddleEastern6.png", "MiddleEastern.png", "MiddleEastern2.png",
		 "MiddleEastern3.png", "MiddleEastern4.png", "MiddleEastern5.png"], 800, true],
	["Misc", true, ["Misc.png", "Misc2.png"], 1125, true],
	["Pizza", true, ["Pizza.png", "Pizza2.png"], 1125, true],
	["Pub", true, ["Pub.png", "Pub2.png", "Pub3.png"], 1125, true],
	["Seafood", true, ["Seafood1.png", "Seafood2.png"], 1125, true],
	["Steakhouse", true, ["Steakhouse.png", "Steakhouse2.png"], 1125, true],
	["Street Vendor", true, 
		["StreetVendor1.png", "StreetVendor2.png", "StreetVendor3.png", 
		 "StreetVendor4.png"], 1000, true],
	["Sushi", true, ["Sushi.png", "Sushi2.png"], 1125, true],
	["Vegetarian", true, ["Vegetarian.png", "Vegetarian2.png"], 1125, true],
	[null, false, ["xtra_Cake.png"], 0, true, null],
	[null, false, ["xtra_CandyApple.png"], 0, true, null],
	[null, false, ["xtra_Doughnut.png"], 0, true, null],
	[null, false, ["xtra_Fish.png"], 0, true, null],
	[null, false, ["xtra_Martini.png"], 0, true, null],
	[null, false, ["xtra_Octopus.png"], 0, true, null],
	[null, false, ["xtra_Sundae.png"], 0, true, null]
];

var defaultRestaurants = [
	{
		name: 'Dibella\'s Subs',
		enabled: true,
		category: 7,
		address: '420 Jefferson Road\nRochester, NY',
		tel: '(585) 475-1831',
		fax: null,
		web: 'http://www.dibellas.com',
		rating: 4,
		price: 1
	},
	{
		name: 'Carter Brothers BBQ',
		enabled: true,
		category: 2,
		address: '3802 Samet Drive\nHigh Point, NC',
		tel: '(336) 869-9948',
		fax: null,
		web: 'http://www.carterbrothersbbq.com',
		rating: 4,
		price: 1
	},
	{
		name: 'Pacific Catch',
		enabled: true,
		category: 18,
		address: '133 Corte Madera Town Center\nCorte Madera, CA',
		tel: '(415) 927-3474',
		fax: null,
		web: 'http://www.pacificcatch.com',
		rating: 4,
		price: 2
	}
];

var restaurants = null;
var categories = null;

function initDineomatic()
{
	// dashcode's setup
	setupParts();
	
	if (window.widget) {
		tabView = new DOMTabView();
		
		tabView.addView(
			document.getElementById('tabViewRestaurantContent'),
			document.getElementById('tabViewRestaurantTab'),
			getLocalizedString('Restaurants'),
			79, 21,
			'Images/tab_1_off.png',
			'Images/tab_1_on.png',
			'Images/tab_1_over.png',
			true,
			onShowRestaurantTab);
		
		tabView.addView(
			document.getElementById('tabViewCategoryContent'),
			document.getElementById('tabViewCategoryTab'),
			getLocalizedString('Categories'),
			77, 21,
			'Images/tab_2_off.png',
			'Images/tab_2_on.png',
			'Images/tab_2_over.png',
			false,
			onShowCategoryTab);
		
		tabView.addView(
			document.getElementById('tabViewAboutContent'),
			document.getElementById('tabViewAboutTab'),
			getLocalizedString('About'),
			50, 21,
			'Images/tab_3_off.png',
			'Images/tab_3_on.png',
			'Images/tab_3_over.png',
			false,
			onShowAboutTab);
		
		dinnerPlate = new DOMButton(
			document.getElementById('dinnerPlate'),
			48, 48,
			'Images/dinnerPlate_up.png',
			'Images/dinnerPlate_down.png',
			'Images/dinnerPlate_off.png',
			'Images/dinnerPlate_over.png',
			pickRestaurant,
			'circle');
		
		categoryPlusButton = new DOMButton(
			document.getElementById('categoryPlusButton'),
			17, 17,
			'Images/plus_up.png',
			'Images/plus_down.png',
			'Images/plus_off.png',
			null,
			categoryAdd,
			'rectangle');
		
		categoryMinusButton = new DOMButton(
			document.getElementById('categoryMinusButton'),
			17, 17,
			'Images/minus_up.png',
			'Images/minus_down.png',
			'Images/minus_off.png',
			null,
			categoryRemove,
			'rectangle');
		
		restaurantPlusButton = new DOMButton(
			document.getElementById('restaurantPlusButton'),
			17, 17,
			'Images/plus_up.png',
			'Images/plus_down.png',
			'Images/plus_off.png',
			null,
			restaurantAdd,
			'rectangle');
		
		restaurantMinusButton = new DOMButton(
			document.getElementById('restaurantMinusButton'),
			17, 17,
			'Images/minus_up.png',
			'Images/minus_down.png',
			'Images/minus_off.png',
			null,
			restaurantRemove,
			'rectangle');

		var bTop = getLocalizedString('editTop');
		var bLeft = getLocalizedString('editLeft');
		var bWidth = getLocalizedString('editWidth');
		var bHeight = getLocalizedString('editHeight');

		restaurantEditButton = new DOMToggleButton(
			document.getElementById('restaurantEditButton'),
			bTop, bLeft, bWidth, bHeight,
			getLocalizedString('Edit'),
			'Images/edit_middle_up.png',
			'Images/edit_left_up.png',
			'Images/edit_right_up.png',
			'Images/edit_middle_down.png',
			'Images/edit_left_down.png',
			'Images/edit_right_down.png',
			'Images/edit_middle_off.png',
			'Images/edit_left_off.png',
			'Images/edit_right_off.png',
			null,
			null,
			null,
			'Images/edit_middle_toggled.png',
			'Images/edit_left_toggled.png',
			'Images/edit_right_toggled.png',
			restaurantInfoEdit,
			'rectangle');

		bTop = getLocalizedString('doneTop');
		bLeft = getLocalizedString('doneLeft');
		bWidth = getLocalizedString('doneWidth');
		bHeight = getLocalizedString('doneHeight');
		
		doneButton = new DOMTextButton(
			document.getElementById('doneButton'),
			bTop, bLeft, bWidth, bHeight,
			getLocalizedString('Done'),
			'Images/done_middle_up.png',
			'Images/done_left_up.png',
			'Images/done_right_up.png',
			'Images/done_middle_down.png',
			'Images/done_left_down.png',
			'Images/done_right_down.png',
			'Images/done_middle_off.png',
			'Images/done_left_off.png',
			'Images/done_right_off.png',
			null,
			null,
			null,
			showFront,
			'rectangle');

		categoryPlusButton.setEnabled(false);
		categoryMinusButton.setEnabled(false);
		restaurantMinusButton.setEnabled(false);
		restaurantEditButton.setEnabled(false);
		
		/* setup javascript obj commonly in-use all over */
		icon = document.getElementById('icon');

		restaurantBar = document.getElementById('restaurantBar');
		restaurantInfo = document.getElementById('restaurantInfo');
		restaurantInfoMapLink = document.getElementById('restaurantInfoMapLink');
		restaurantInfoWebLink = document.getElementById('restaurantInfoWebLink');
		restaurantInfoAddress = document.getElementById('restaurantInfoAddress');
		restaurantInfoTelLabel = document.getElementById('restaurantInfoTelLabel');
		restaurantInfoTel = document.getElementById('restaurantInfoTel');
		restaurantInfoFaxLabel = document.getElementById('restaurantInfoFaxLabel');
		restaurantInfoFax = document.getElementById('restaurantInfoFax');
		restaurantInfoRatingLabel = document.getElementById('restaurantInfoRatingLabel');
		restaurantInfoRating = document.getElementById('restaurantInfoRating');
		
		categoryListView = new DOMListView(
			document.getElementById('categoryListView'),
			{ 
				columns: 2,
				rowClass: 'row',
				selectedRowClass: 'select',
				onselect: categorySelected,
				onselectionclear: categorySelectionClear,
				backgroundImage: 'url(Images/list-background.png)',
				backgroundPosition: 'top left',
				backgroundRepeat: 'repeat'
			});
		
		categoryNameField = document.getElementById('categoryNameField');
		categoryNameField.addEventListener('keyup', categoryKeyUp, true);
		
		restaurantFavorHigherRated = document.getElementById('restaurantFavorHigherRated');
		
		restaurantListView = new DOMListView(
			document.getElementById('restaurantListView'),
			{ 
				columns: 3,
				rowClass: 'row',
				selectedRowClass: 'select',
				onselect: restaurantSelected,
				onselectionclear: restaurantSelectionClear,
				backgroundImage: 'url(Images/list-background.png)',
				backgroundPosition: 'top left',
				backgroundRepeat: 'repeat'
			});
		
		restaurantInfoNameBack = document.getElementById('restaurantInfoNameBack');
		restaurantInfoAddressBack = document.getElementById('restaurantInfoAddressBack');
		restaurantInfoTelBack = document.getElementById('restaurantInfoTelBack');
		restaurantInfoFaxBack = document.getElementById('restaurantInfoFaxBack');
		restaurantInfoWebBack = document.getElementById('restaurantInfoWebBack');
		restaurantInfoCategoryBack = document.getElementById('restaurantInfoCategoryBack');
		restaurantInfoPriceBack = document.getElementById('restaurantInfoPriceBack');
		restaurantInfoRatingBack = document.getElementById('restaurantInfoRatingBack');
		
		restaurantInfoNameField = document.getElementById('restaurantInfoNameField');
		restaurantInfoNameField.addEventListener('blur', restaurantInfoNameFieldOnBlur, true);
		restaurantInfoAddressField = document.getElementById('restaurantInfoAddressField');
		restaurantInfoTelField = document.getElementById('restaurantInfoTelField');
		restaurantInfoFaxField = document.getElementById('restaurantInfoFaxField');
		restaurantInfoWebField = document.getElementById('restaurantInfoWebField');
		
		restaurantInfoCategoryField = new DOMPopup(
			document.getElementById('restaurantInfoCategoryField'),
			[], [],	[],
			18, 
			'Images/dropdown_left.png', 5,
			'Images/dropdown_center.png', 122,
			'popup',
			'Images/dropdown_right.png', 23,
			null);
		
		restaurantInfoPriceField = new DOMPopup(
			document.getElementById('restaurantInfoPriceField'),
			['<img src="Images/price_dd_1.png" alt="">',
			 '<img src="Images/price_dd_2.png" alt="">',
			 '<img src="Images/price_dd_3.png" alt="">',
			 '<img src="Images/price_dd_4.png" alt="">'],
			['$', '$$', '$$$', '$$$$'],
			['1', '2', '3', '4'],
			18,
			'Images/dropdown_left.png', 5,
			'Images/dropdown_center.png', 44,
			'popup',
			'Images/dropdown_right.png', 23,
			null);

		restaurantInfoRatingField = new DOMPopup(
			document.getElementById('restaurantInfoRatingField'),
			['<img src="Images/rating_dd_1.png" alt="">',
			 '<img src="Images/rating_dd_2.png" alt="">',
			 '<img src="Images/rating_dd_3.png" alt="">',
			 '<img src="Images/rating_dd_4.png" alt="">'],
			['★', '★★', '★★★', '★★★★'],
			['1', '2', '3', '4'],
			18,
			'Images/dropdown_left.png', 5,
			'Images/dropdown_center.png', 44,
			'popup',
			'Images/dropdown_right.png', 23,
			null);
		
		// warning box to warn about duplicate restaurant names
		noticebox = new DOMNoticeBox(document.getElementById('noticebox'));
		
		sndButton = document.getElementById('sndButton');
		
		// hide translator for select languages (currently only english)
		if (getLocalizedString('hideTranslation') == 'true') {
			document.getElementById('aboutTextTranslation').style.display = 'none';
			document.getElementById('aboutTextTranslator').style.display = 'none';
		}
		
		// load diners stored in preferences
		categoryLoad();
		restaurantLoad();
		favorConfigLoad();
		soundConfigLoad();
		
		restaurantInfoDisable();
		restaurantInfoReloadCategoryPopup();
		
		// create initial restarant pool
		restaurantCreatePool();
		
		// set default icon
		setIcon();
		
		widgetHidden = false;
	}
}

function categoryLoad()
{
	var categoriesStr = widget.preferenceForKey('categories');
	
	if (!empty(categoriesStr)) {
		categories = eval(categoriesStr);
	}
	else {
		// make array copy
		categories = defaultCategories.slice();
	}
	
	categorySort();
	categoryReload();
}

function categoryReload()
{
	categoryListView.clear();
	
	for (var i = 0; i < categories.length; i++) {
		if (categories[i][0] != null) {
			categoryAddRowAtIndex(-1, categories[i]);
		}
	}
	
	categoryListView.refresh();
}

function categorySort()
{
	var defaultCategories = new Array();
	var userCategories = new Array();
	
	for (var i = 0; i < categories.length; i++) {
		if (categories[i][4]) {
			defaultCategories.push(categories[i]);
		}
		else {
			userCategories.push(categories[i]);
		}
	}
	
	defaultCategories = defaultCategories.sort(
		function(a, b) {
			if (a[0] == null) {
				return 1;
			}
			else if (b[0] == null) {
				return -1;
			}
			else if (lowercase(a[0]) < lowercase(b[0])) {
				return -1;
			}
			else if (lowercase(a[0]) > lowercase(b[0])) {
				return 1;
			}
			else {
				return 0;
			}
		}
	);

	userCategories = userCategories.sort(
		function(a, b) {
			if (a[0] == null) {
				return 1;
			}
			else if (b[0] == null) {
				return -1;
			}
			else if (lowercase(a[0]) < lowercase(b[0])) {
				return -1;
			}
			else if (lowercase(a[0]) > lowercase(b[0])) {
				return 1;
			}
			else {
				return 0;
			}
		}
	);
	
	categories = defaultCategories.concat(userCategories);
}

function categoryAdd(event)
{
	var categoryName = trim(categoryNameField.value);
	
	if (!empty(categoryName) && !categoryExists(categoryName)) {
		
		//
		// insert category into array sorted
		//
		
		var lCategoryName = lowercase(categoryName);
		var i = numDefaultCategories;
		
		while (i < categories.length && (lowercase(categories[i][0]) < lCategoryName)) {
			i++;
		}
		
		// add element sorted by category name
		categories.splice(i, 0, [categoryName, true, ['Misc.png', 'Misc2.png'], 1125, false, null]);
		
		// need to update any restaurants whose category
		// index is affected by this.. A better idea would
		// be to use a pointer into the category array, but
		// saving and loading restaurant preferences would need
		// to be changed..
		
		for (var j = 0; j < restaurants.length; j++) {
			if (restaurants[j].category >= i) {
				restaurants[j].category++;
			}
		}
		
		// append category to listview
		var row = categoryAddRowAtIndex(i - numNullCategories, categories[i]);
		
		// refresh listview
		categoryListView.refresh();
		categoryListView.selectAndReveal(row);
		
		// manually fire handler, only onclicks auto-fire handler
		categorySelected(row);

		// reset input field
		categoryPlusButton.setEnabled(false);
		categoryNameField.value = '';
		categoryNameField.focus();
		
		prefsChanged['categories'] = true;
	}
}

function categoryAddRowAtIndex(index, category)
{
	var checkbox = document.createElement('input');
	checkbox.type = 'checkbox';
	checkbox.checked = category[1];
	checkbox.addEventListener('change', categoryChanged, true);
	
	var categoryspan = document.createElement('span');
	categoryspan.className = 'categoryNameColumn';
	categoryspan.innerText = getLocalizedString(category[0]);
	
	var row = categoryListView.insert([checkbox, categoryspan], index);

	// set Dine-O-Matic specific row attributes
	row.category = category;
	row.defaultCategory = category[4];
	
	// change CSS class to bold default categories
	if (row.defaultCategory) {
		row.className += ' default-category';
	}
	
	return row;
}

function categoryRemove(event)
{
	var categoryIndex = categoryListView.selectedIndex() + numNullCategories;
	
	// remove row from data array and listview
	var i = 0;

	while (i < restaurants.length) {
		//alert('checking restaurant[' + i + ']: ' + restaurants[i].name);
		if (restaurants[i].category == categoryIndex) {
			restaurantRemoveIndex(i);
		}
		else {
			//alert('category check for restaurant[' + i + ']: ' + restaurants[i].category + ' > '  + categoryIndex);
			if (restaurants[i].category > categoryIndex) {
				//alert('category decrease restaurant[' + i + '].category: ' + restaurants[i].category);
				restaurants[i].category -= 1;
			}
			i++;
		}
	}
	
	categories.splice(categoryIndex, 1);
	categoryListView.removeSelected();
	categoryMinusButton.setEnabled(false);
	
	// focus input field
	categoryNameField.focus();
	categoryNameField.select();
	
	prefsChanged['restaurants'] = true;
	prefsChanged['categories'] = true;
}

function categorySelected(row)
{
	if (row.defaultCategory) {
		// disable removal of default categories
		categoryMinusButton.setEnabled(false);
	}
	else {
		// allow removal
		categoryMinusButton.setEnabled(true);
	}
}

function categorySelectionClear()
{
	categoryMinusButton.setEnabled(false);
}

function categoryExists(name)
{
	for (var i = 0; i < categories.length; i++) {
		if (name == categories[i][0]) {
			return true;
		}
	}
	
	return false;
}

function categoryKeyUp(event)
{
	if (empty(categoryNameField.value)) {
		categoryPlusButton.setEnabled(false);
	}
	else {
		categoryPlusButton.setEnabled(true);
	}
	
	if (event) {
		event.stopPropagation();
		event.preventDefault();
	}
}

function categoryChanged(event)
{
	var row = event.target.parentNode;
	
	if (row.category != null) {
		row.category[1] = event.target.checked;
		prefsChanged['categories'] = true;
	}
	
	if (event) {
		event.stopPropagation();
		event.preventDefault();
	}
}

function restaurantLoad()
{
	var restaurantsStr = widget.preferenceForKey('restaurants');
	var v1diners = restaurantGetv1Diners();
	
	if (v1diners != null && v1diners.length > 0) {
		restaurants = v1diners.slice();
	}
	else if (!empty(restaurantsStr)) {
		restaurants = eval(restaurantsStr);
	}
	else {
		restaurants = defaultRestaurants.slice();
	}
	
	// update restaurant area
	restaurantSort();
	restaurantReload();
}

function restaurantGetv1Diners()
{
	var dinerDataStr = widget.preferenceForKey('dinerData');
	var dinerData = null;
	var convertedRestaurants = null;
	
	if (!empty(dinerDataStr)) {
		dinerData = eval(dinerDataStr);
		
		// allocate some space
		convertedRestaurants = new Array();
		
		// convert old diner format to new restaurant format
		for (var i = 0; i < dinerData.length; i++) {
			convertedRestaurants.push(
				{
					name: dinerData[i].name,
					enabled: true,
					category: dinerData[i].type,
					address: null,
					tel: null,
					fax: null,
					web: null,
					rating: 1,
					price: 1
				});
		}
	}
	
	return convertedRestaurants;
}

function restaurantReload()
{
	// this will also clear the selection
	// invoking restaurantSelectionClear, in turn
	// resetting any restaurant information data
	
	restaurantListView.clear();
	
	if (restaurants != null) {
		for (var i = 0; i < restaurants.length; i++) {
			restaurantAddRowAtIndex(-1, restaurants[i]);
		}
	}
	
	restaurantListView.refresh();
}

function restaurantSort()
{	
	restaurants = restaurants.sort(
		function(a, b) {
			if (lowercase(a.name) < lowercase(b.name)) {
				return -1;
			}
			else if (lowercase(a.name) > lowercase(b.name)) {
				return 1;
			}
			else {
				return 0;
			}
		}
	);
}

function restaurantAdd(event)
{
	var newRestaurant = {
		name: 'Untitled',
		enabled: true,
		category: 0,
		address: null,
		tel: null,
		fax: null,
		web: null,
		price: 1,
		rating: 1
	};
	
	if (REMO) {
		// only allow one new entry at-a-time
		if (REMO['new_entry'] && restaurantIsEntryBlank()) {
			restaurantInfoNameField.focus();
			restaurantInfoNameField.select();
			
			return;
		}
		
		// add row to listview
		var row = restaurantAddRowAtIndex(-1, newRestaurant);
		restaurantREMOSwap(row);
	}
	else {
		// add row to listview
		var row = restaurantAddRowAtIndex(-1, newRestaurant);
		restaurantREMOCreate(row, true);
	}
	
	restaurantListView.refresh();
	restaurantListView.selectAndReveal(row);
	
	// manually toggle button here.. argh!
	restaurantMinusButton.setEnabled(true);
	restaurantEditButton.setEnabled(true);
	restaurantEditButton.setToggled(true);
	
	// update name field to Untitled...
	restaurantInfoUpdate(row);
	
	// enter edit mode
	restaurantInfoEnterEditMode();
}

function restaurantAddRowAtIndex(index, restaurant)
{
	var category = categories[restaurant.category];
	
	var checkbox = document.createElement('input');
	checkbox.type = 'checkbox';
	checkbox.checked = restaurant.enabled;
	checkbox.disabled = !category[1];
	checkbox.addEventListener('change', restaurantChanged, true);
	
	var restaurantspan = document.createElement('span');
	restaurantspan.className = 'restaurantNameColumn';
	restaurantspan.innerText = restaurant.name;
	
	var categoryspan = document.createElement('span');
	categoryspan.className = 'restaurantCategoryColumn';
	categoryspan.innerText = getLocalizedString(category[0]);
	
	var row = restaurantListView.insert([checkbox, restaurantspan, categoryspan], index);
	row.restaurant = restaurant;
	
	return row;
}

function restaurantRemoveIndex(index)
{
	//alert('removing restaurant[' + index + ']\n' + restaurantToString(restaurant[index]));
	
	if (index != -1) {
		if (pickedRestaurant != null && pickedRestaurant == restaurants[index]) {
			prefsChanged['resetIcon'] = true;
		}
		
		// remove row from data array and listview
		restaurants.splice(index, 1);
		prefsChanged['restaurants'] = true;
	}
}

function restaurantRemove(event)
{
	var row = restaurantListView.selected();
	var index = restaurantFindIndex(row.restaurant);
	
	if (row && (REMO == null || REMO['new_entry'] == false)) {
		// done remove new_entry 'untitled' row
		// restaurantREMOSwap() will remove it later
		restaurantListView.removeSelected();
	}
	
	// remove restaurant from array
	restaurantRemoveIndex(index);
	
	if (restaurants.length > 0) {
		index = (index == -1) ? restaurants.length - 1 : index;
		index = (index == restaurants.length) ? index - 1 : index;
		
		row = restaurantListView.selectIndex(index);
		restaurantSelected(row, null);
	}
	else {
		if (REMO != null) {
			restaurantInfoLeaveEditMode();
		}
		
		restaurantSelectionClear();
	}
}

function restaurantSelected(row, oldrow)
{
	// swap out REMO
	if (REMO != null) {
		restaurantREMOSwap(row);
	}
	else {
		restaurantMinusButton.setEnabled(true);
		restaurantEditButton.setEnabled(true);
	}
	
	// update restaurant info divs
	restaurantInfoUpdate(row);
}

function restaurantSelectionClear()
{
	// clear out any info since we lost the selection
	restaurantInfoClear();
	
	restaurantMinusButton.setEnabled(false);
	restaurantEditButton.setEnabled(false);
}

function restaurantChanged(event)
{
	var row = event.target.parentNode;
	
	if (row.restaurant != null) {
		row.restaurant.enabled = event.target.checked;
		prefsChanged['restaurants'] = true;
	}
	
	if (event) {
		event.stopPropagation();
		event.preventDefault();
	}
}

function restaurantInfoDisable()
{
	restaurantInfoNameField.disabled = true;
	restaurantInfoAddressField.disabled = true;
	restaurantInfoTelField.disabled = true;
	restaurantInfoFaxField.disabled = true;
	restaurantInfoWebField.disabled = true;
	restaurantInfoCategoryField.setEnabled(false);
	restaurantInfoPriceField.setEnabled(false);
	restaurantInfoRatingField.setEnabled(false);

	restaurantInfoNameField.style.display = 'none';
	restaurantInfoAddressField.style.display = 'none';
	restaurantInfoTelField.style.display = 'none';
	restaurantInfoFaxField.style.display = 'none';
	restaurantInfoWebField.style.display = 'none';
	restaurantInfoCategoryField.style.display = 'none';
	restaurantInfoPriceField.style.display = 'none';
	restaurantInfoRatingField.style.display = 'none';

	restaurantInfoNameBack.style.display = 'block';
	restaurantInfoAddressBack.style.display = 'block';
	restaurantInfoTelBack.style.display = 'block';
	restaurantInfoFaxBack.style.display = 'block';
	restaurantInfoWebBack.style.display = 'block';
	restaurantInfoCategoryBack.style.display = 'block';
	restaurantInfoPriceBack.style.display = 'block';
	restaurantInfoRatingBack.style.display = 'block';
}

function restaurantInfoEnable()
{
	restaurantInfoNameBack.style.display = 'none';
	restaurantInfoAddressBack.style.display = 'none';
	restaurantInfoTelBack.style.display = 'none';
	restaurantInfoFaxBack.style.display = 'none';
	restaurantInfoWebBack.style.display = 'none';
	restaurantInfoCategoryBack.style.display = 'none';
	restaurantInfoPriceBack.style.display = 'none';
	restaurantInfoRatingBack.style.display = 'none';
	
	restaurantInfoNameField.disabled = false;
	restaurantInfoAddressField.disabled = false;
	restaurantInfoTelField.disabled = false;
	restaurantInfoFaxField.disabled = false;
	restaurantInfoWebField.disabled = false;
	restaurantInfoCategoryField.setEnabled(true);
	restaurantInfoPriceField.setEnabled(true);
	restaurantInfoRatingField.setEnabled(true);
	
	restaurantInfoNameField.style.display = 'block';
	restaurantInfoAddressField.style.display = 'block';
	restaurantInfoTelField.style.display = 'block';
	restaurantInfoFaxField.style.display = 'block';
	restaurantInfoWebField.style.display = 'block';
	restaurantInfoCategoryField.style.display = 'block';
	restaurantInfoPriceField.style.display = 'block';
	restaurantInfoRatingField.style.display = 'block';
}

function restaurantInfoClear()
{
	restaurantInfoNameBack.innerText = '';
	restaurantInfoAddressBack.innerText = '';
	restaurantInfoTelBack.innerText = '';
	restaurantInfoFaxBack.innerText = '';
	restaurantInfoWebBack.innerText = '';
	restaurantInfoCategoryBack.innerText = '';
	restaurantInfoPriceBack.innerText = '';
	restaurantInfoRatingBack.innerText = '';

	restaurantInfoNameField.value = '';
	restaurantInfoAddressField.value = '';
	restaurantInfoTelField.value = '';
	restaurantInfoFaxField.value = '';
	restaurantInfoWebField.value = '';
	restaurantInfoCategoryField.setSelectedIndex(0);
	restaurantInfoPriceField.setSelectedIndex(0);
	restaurantInfoRatingField.setSelectedIndex(0);
}

function restaurantInfoUpdate(row)
{
	var tmpHTML = null;
	
	if (row == null) {
		restaurantInfoClear();
	}
	else {
		var restaurant = row.restaurant;
		
		if (restaurant == null) {
			return;
		}
	
		restaurantInfoNameBack.innerText = restaurant.name;
		restaurantInfoAddressBack.innerText = isnull(restaurant.address, '');
		restaurantInfoTelBack.innerText = isnull(restaurant.tel, '');
		restaurantInfoFaxBack.innerText = isnull(restaurant.fax, '');
		restaurantInfoWebBack.innerText = isnull(restaurant.web, '');
		restaurantInfoCategoryBack.innerText = getLocalizedString(categories[restaurant.category][0]);
		
		tmpHTML = '';
		for (var i = 0; i < restaurant.price; i++) {
			tmpHTML += '<img src="Images/dollar_back.png" style="width: 11px; height: 18px;" alt="">';
		}
		restaurantInfoPriceBack.innerHTML = tmpHTML;
		
		tmpHTML = '';
		for (var i = 0; i < restaurant.rating; i++) {
			tmpHTML += '<img src="Images/star_back.png" style="width: 11px; height: 18px;" alt="">';
		}
		restaurantInfoRatingBack.innerHTML = tmpHTML;
		
		restaurantInfoNameField.value = restaurant.name;
		restaurantInfoAddressField.value = isnull(restaurant.address, '');
		restaurantInfoTelField.value = isnull(restaurant.tel, '');
		restaurantInfoFaxField.value = isnull(restaurant.fax, '');
		restaurantInfoWebField.value = isnull(restaurant.web, '');
		restaurantInfoCategoryField.setValue(restaurant.category);
		restaurantInfoPriceField.setValue(restaurant.price);
		restaurantInfoRatingField.setValue(restaurant.rating);
		
		row.childNodes[2].innerText = getLocalizedString(categories[restaurant.category][0]);
	}
}

function restaurantInfoEdit(event, toggled)
{
	if (toggled) {
		restaurantREMOCreate(restaurantListView.selected(), false);
		restaurantInfoEnterEditMode();
	}
	else {
		restaurantInfoLeaveEditMode();
	}
}

function restaurantInfoEnterEditMode()
{
	restaurantFavorHigherRated.disabled = true;
	doneButton.setEnabled(false);
	tabView.setEnabled(false);
	
	//restaurantREMOPrint();
	restaurantInfoEnable();
	
	restaurantInfoNameField.focus();
	restaurantInfoNameField.select();
}

function restaurantInfoLeaveEditMode()
{
	var row = restaurantREMOSwap(null);
	
	// refresh listview showing last row
	restaurantListView.refresh();
	restaurantListView.selectAndReveal(row);
	
	// redundant if row if row != null
	restaurantListView.revealSelected();
	
	// swap edit view for readonly view
	restaurantInfoDisable();
	restaurantInfoUpdate(restaurantListView.selected());
	
	restaurantFavorHigherRated.disabled = false;
	doneButton.setEnabled(true);
	tabView.setEnabled(true);
}

function restaurantInfoNameFieldOnBlur(event)
{
	if (empty(restaurantInfoNameField.value)) {
		restaurantInfoNameField.value = 'Untitled';
		restaurantInfoNameField.focus();
		restaurantInfoNameField.select();
		
		// show noticebox!
	}
	
	if (event) {
		event.stopPropagation();
		event.preventDefault();
	}
}

function restaurantInfoReloadCategoryPopup()
{
	var htmlValues = new Array();
	var textValues = new Array();
	var values = new Array();
	
	for (var i = 0; i < categories.length; i++) {
		if (categories[i][0] != null) {
			htmlValues.push(getLocalizedString(categories[i][0]));
			textValues.push(getLocalizedString(categories[i][0]));
			values.push(i);
		}
	}
	
	restaurantInfoCategoryField.setValues(htmlValues, textValues, values);
}

function restaurantInfoToggle(event)
{
	// Toggle restaurat information
	// extra pane on the front of the
	// widget...

	if (restaurantInfo.style.display == 'block') {
		restaurantInfoHide();
	}
	else {
		restaurantInfoShow();
	}
	
	if (event) {
		event.stopPropagation();
		event.preventDefault();
	}
}

function restaurantInfoShow()
{
	window.resizeTo(FRONT_WIDTH_INFO, FRONT_HEIGHT_INFO);
	restaurantInfo.style.display = 'block';
}

function restaurantInfoHide()
{
	restaurantInfo.style.display = 'none';
	window.resizeTo(FRONT_WIDTH, FRONT_HEIGHT);
}

function restaurantInfoMapIt(event)
{
	var mapURL = null;
	var address = null;
	
	if (pickedRestaurant != null) {
		if (!empty(pickedRestaurant.address)) {
			mapURL = getLocalizedString('MapURL');
			address = pickedRestaurant.address;
			
			// replace whitespaces
			address = address.replace(/ /gi, '+');
			address = address.replace(/\n/gi, '+');
			address = address.replace(/\t/gi, '+');
			address = escape(address);

			openURL(mapURL.replace(/%s/gi, address));
		}
	}

	if (event) {
		event.stopPropagation();
		event.preventDefault();
	}
}

function restaurantInfoWebIt(event)
{
	if (pickedRestaurant != null) {
		if (!empty(pickedRestaurant.web)) {
			openURL(pickedRestaurant.web);
		}
	}

	if (event) {
		event.stopPropagation();
		event.preventDefault();
	}
}

function restaurantIsEntryBlank() {
	var nameField = trim(restaurantInfoNameField.value);
	
	if (empty(nameField)) {
		nameField = 'Untitled';
	}
	
	return (nameField == 'Untitled' &&
			empty(restaurantInfoAddressField.value) &&
			empty(restaurantInfoTelField.value) &&
			empty(restaurantInfoFaxField.value) &&
			empty(restaurantInfoWebField.value) &&
			restaurantInfoCategoryField.value == 0 &&
			restaurantInfoPriceField.value == 1 &&
			restaurantInfoRatingField.value == 1);
}

function restaurantDidEntryChange() {
	if (REMO == null || REMO['row'] == null || REMO['row'].restaurant == null) {
		return false;
	}

	var restaurant = REMO['row'].restaurant;
	
	return (trim(restaurantInfoNameField.value) != isnull(restaurant.name, '') ||
			restaurantInfoAddressField.value != isnull(restaurant.address, '') ||
			restaurantInfoTelField.value != isnull(restaurant.tel, '') ||
			restaurantInfoFaxField.value != isnull(restaurant.fax, '') ||
			restaurantInfoWebField.value != isnull(restaurant.web, '') ||
			restaurantInfoCategoryField.value != restaurant.category ||
			restaurantInfoPriceField.value != restaurant.price ||
			restaurantInfoRatingField.value != restaurant.rating);
}

function restaurantDidNameEntryChange() {
	if (REMO == null || REMO['row'] == null || REMO['row'].restaurant == null) {
		return false;
	}
	
	return (trim(restaurantInfoNameField.value) != isnull(REMO['row'].restaurant.name, ''));
}

function restaurantREMOCreate(row, new_entry)
{
	restaurantREMODestroy();
	
	if (row != null) {
		REMO = new Object;
		REMO['row'] = row;
		REMO['new_entry'] = new_entry;
	}
}

function restaurantREMODestroy()
{
	if (REMO != null) {
		delete REMO;
		REMO = null;
	}
}

function restaurantREMOSwap(newrow)
{
	var insertedRow = null;
	
	if (REMO != null) {
		if (REMO['new_entry']) {
			restaurantREMORemove();
			
			if (!restaurantIsEntryBlank()) {
				// add new restaurant
				insertedRow = restaurantREMOInsert();
			}
		}
		else if (restaurantDidNameEntryChange()) {
			restaurantREMORemove();
			insertedRow = restaurantREMOInsert();
		}
		else if (restaurantDidEntryChange()) {
			restaurantREMOUpdate();
		}
	}
	
	// create new REMO
	restaurantREMOCreate(newrow, false);
	
	// debug output
	//alert(restaurantsToString());
	
	return insertedRow;
}

function restaurantREMOInsert()
{
	var row = null;
	
	var restaurant = {
		name: restaurantInfoNameField.value,
		enabled: true,
		address: restaurantInfoAddressField.value,
		tel: restaurantInfoTelField.value,
		fax: restaurantInfoFaxField.value,
		web: restaurantInfoWebField.value,
		category: restaurantInfoCategoryField.value,
		price: restaurantInfoPriceField.value,
		rating: restaurantInfoRatingField.value
	};
	
	// find index to keep restaurants sorted
	var lRestaurantName = lowercase(restaurant.name);
	var i = 0;
	
	while (i < restaurants.length && (lowercase(restaurants[i].name) < lRestaurantName)) {
		i++;
	}
	
	// add in new or edit restaurant in sorted order
	restaurants.splice(i, 0, restaurant);
	
	row = restaurantAddRowAtIndex(i, restaurant);
	
	prefsChanged['restaurants'] = true;
	
	return row;
}

function restaurantREMORemove()
{
	var index = restaurantFindIndex(REMO['row'].restaurant);
	
	// if not removing Untitled, pull from array also
	restaurantRemoveIndex(index);
	
	// remove from view
	restaurantListView.remove(REMO['row']);
}

function restaurantREMOUpdate()
{
	// pointer like changes?
	var restaurant = REMO['row'].restaurant;
	
	// name, enabled not effected
	restaurant.address = restaurantInfoAddressField.value;
	restaurant.tel = restaurantInfoTelField.value;
	restaurant.fax = restaurantInfoFaxField.value;
	restaurant.web = restaurantInfoWebField.value;
	restaurant.category = restaurantInfoCategoryField.value;
	restaurant.price = restaurantInfoPriceField.value;
	restaurant.rating = restaurantInfoRatingField.value;
	
	restaurantInfoUpdate(REMO['row']);
	
	prefsChanged['restaurants'] = true;
}

function restaurantREMOPrint()
{
	if (REMO == null) {
		alert('Restaurant Edit Mode Object is null');
	}
	else {
		var str = 'Restaurant Edit Mode Object\n';
		str += '\tREMO[restaurant]\n' + restaurantToString(REMO['row'].restaurant) + '\n';
		str += '\tREMO[new_entry]: ' + REMO['new_entry'];
		alert(str);
	}
}

function restaurantFindIndex(restaurant)
{
	for (var i = 0; i < restaurants.length; i++) {
		if (restaurants[i] == restaurant) {
			return i;
		}
	}
	
	return -1;
}

function restaurantToString(restaurant)
{
	var str = '';
	
	str += '\t\tname: ' + restaurant.name;
	str += '\n';
	str += '\t\taddress: ' + restaurant.address;
	str += '\n';
	str += '\t\ttel: ' + restaurant.tel;
	str += '\n';
	str += '\t\tfax: ' + restaurant.fax;
	str += '\n';
	str += '\t\tweb: ' + restaurant.web;
	str += '\n';
	str += '\t\tcategory: ' + categories[restaurant.category][0];
	str += '\n';
	str += '\t\tprice: ' + restaurant.price;
	str += '\n';
	str += '\t\trating: ' + restaurant.rating;
		
	return str;
}

function restaurantsToString(rArray, nameonly)
{
	if (rArray === undefined || rArray == null) {
		rArray = restaurants;
	}

	if (nameonly === undefined || nameonly == null) {
		nameonly = false;
	}
	
	var r = new Array();
	
	for (var i = 0; i < rArray.length; i++) {
		if (nameonly) {
			r.push('[' + i + ']' + isnull(rArray[i].name, '<null>'));
		}
		else {
			r.push('[' + i + ']' + restaurantToString(rArray[i]));
		}
	}
	
	if (r.length == 0) {
		return null;
	}
	
	return '\n' + r.join('\n');
}

function soundConfigLoad()
{
	/* load sound config */
	if (widget.preferenceForKey('soundEnabled') != undefined) {
		soundEnabled = widget.preferenceForKey('soundEnabled');
	}

	sndButton.src = 'Images/' + ((soundEnabled) ? 'sound_on.png' : 'sound_off.png');
}

function soundToggle(event)
{	
	if (soundEnabled) {
		sndButton.src = 'Images/sound_off.png';
	}
	else {
		sndButton.src = 'Images/sound_on.png';
	}
	
	soundEnabled = !soundEnabled;
	prefsChanged['sound'] = true;
	
	if (event) {
		event.stopPropagation();
		event.preventDefault();
	}
}

function favorConfigLoad()
{
	/* load sound config */
	if (widget.preferenceForKey('favorHigherRated') !== undefined) {
		favorHigherRated = widget.preferenceForKey('favorHigherRated');
	}
}

function favorToggle(event)
{
	favorHigherRated = restaurantFavorHigherRated.checked;
	prefsChanged['favorHigherRated'] = true;
	
	if (event) {
		event.stopPropagation();
		event.preventDefault();
	}
}

function sliderItemDown(event, prefix, idx)
{
	sliderPrefix = prefix;
	document.addEventListener('mouseup', sliderItemUp, true);
	document.addEventListener('mousemove', sliderItemMove, true);
	
	toggleSliderItems(idx);
	
	if (event) {
		event.stopPropagation();
		event.preventDefault();
	}
}

function sliderItemUp(event)
{
	document.removeEventListener('mousemove', sliderItemMove, true);
	document.removeEventListener('mouseup', sliderItemUp, true);
	sliderPrefix = null;
	
	// user filter for rating/price changed, update restaurant pool
	restaurantCreatePool();
	
	if (event) {
		event.stopPropagation();
		event.preventDefault();
	}
}

function sliderItemMove(event)
{
	var item1 = document.getElementById(sliderPrefix + '1');
	var item2 = document.getElementById(sliderPrefix + '2');
	var item3 = document.getElementById(sliderPrefix + '3');
	var item4 = document.getElementById(sliderPrefix + '4');

	//alert("move item1: " + (parseInt(item1.style.top) + parseInt(item1.style.height)));
	//alert("move item2: " + (parseInt(item2.style.top) + parseInt(item1.style.height)));
	//alert("move item3: " + (parseInt(item3.style.top) + parseInt(item1.style.height)));
	//alert("move item4: " + (parseInt(item4.style.top) + parseInt(item1.style.height)));
	//alert("event.y: " + event.y);
	
	var y = parseInt(event.y);
	var i1y = parseInt(item1.style.top) + parseInt(item1.style.height);
	var i2y = parseInt(item2.style.top) + parseInt(item2.style.height);
	var i3y = parseInt(item3.style.top) + parseInt(item3.style.height);
	var i4y = parseInt(item4.style.top) + parseInt(item4.style.height);
	
	// order matters here
	if (y <= i4y) {
		toggleSliderItems(4);
	}
	else if (y <= i3y) {
		toggleSliderItems(3);
	}
	else if (y <= i2y) {
		toggleSliderItems(2);
	}
	else if (y <= i1y) {
		toggleSliderItems(1);
	}
	else {
		//toggleSliderItems(0);
	}
	
	if (event) {
		event.stopPropagation();
		event.preventDefault();
	}
}

function toggleSliderItems(idx)
{
	var item = null;
	
	if (sliderPrefix) {
		pickOptions[sliderPrefix] = parseInt(idx);
		
		for (var i = idx; i > 0; i--) {
			item = document.getElementById(sliderPrefix + i);
			if (item) {
				item.src = 'Images/' + sliderPrefix + i + 'on.png';
			}
		}
		
		for (var i = idx + 1; i < 5; i++) {
			item = document.getElementById(sliderPrefix + i);
			if (item) {
				item.src = 'Images/' + sliderPrefix + i + 'off.png';
			}
		}               
	}
}

function restaurantCreatePool()
{
	// need to make up a pool of restaurants to choose from
	// based on rating and price selection
	
	delete restaurantPool;
	restaurantPool = null;
	restaurantPool = new Array();
	
	for (var i = 0; i < restaurants.length; i++) {
		if (restaurants[i].enabled &&
			categories[restaurants[i].category][1] &&
			restaurants[i].price <= pickOptions['price']) {
			// push qualified restaurant in pool
			restaurantPool.push(restaurants[i]);
			
			// if favor higher rated...
			if (favorHigherRated) {
				for (var j = 1; j < restaurants[i].rating; j++) {
					restaurantPool.push(restaurants[i]);
				}
			}
		}
	}
	
	// randomize pool
	restaurantPool.sort(randOrd);
	
	// debug output
	//alert(restaurantsToString(restaurantPool, true));
	
	if (restaurantPool.length < 1) {
		pickedRestaurant = null;
	}
	
	// reset icon, new selection
	setIcon();
}

function randOrd()
{
	return (Math.round(Math.random()) - 0.5);
}

function pickRestaurant(event)
{
	if (vending) {
		if (event) {
			event.stopPropagation();
			event.preventDefault();
		}
		
		return;
	}

	vending = true;
	dinnerPlate.setEnabled(false);
	
	if (faderAnimator) {
		faderAnimator.stop();
		faderAnimator = null;
	}
	
	stopIconTimer();
	setRestaurantBarText('', '', '', '', 0, false, 0);
	
	// shuffle diner icon
	restaurantBar.style.opacity = 0;
	setRestaurantInfoOpacity(0);

	shuffleCount = -1;
	shuffleFinalDelay = -1;
	randNum = -1;
	neonPlayCount = 0;

	stopSound();
	if (soundEnabled) {
		playSound('Activate');
	}
	else {
		setTimeout('ActivateSoundFinished()', 250);
	}
}

function ActivateSoundFinished()
{
	if (vending) {
		setTimeout('vend()', 25);
	}
}

function VendSoundFinished()
{
	if (vending) {
		++shuffleCount;
		
		if (shuffleCount < shuffleFullSpdClicks) {
			vend();
		}
		else if (shuffleCount < shuffleMax) {
			setTimeout('vend()',
				shuffleExpDelay + 
					Math.pow(shuffleCount - shuffleFullSpdClicks, shuffleExp));
		}
		else {
			shuffleFinalDelay = 1.35 * 
				(shuffleExpDelay + 
					Math.pow(shuffleCount - shuffleFullSpdClicks, shuffleExp));
			setTimeout('setFinalRestaurantIcon()', shuffleFinalDelay);
		}
	}
}

function SelectSoundFinished()
{
	if (soundEnabled && !vending && !widgetHidden && neonPlayCount == 0) {
		setTimeout("playSound('Neon')", 850);
	}
}

function NeonSoundFinished()
{
	neonPlayCount++;
	if (soundEnabled && !vending && !widgetHidden && neonPlayCount == 1) {
		setTimeout("playSound('Neon')", 600);
	}
}

function vend()
{
	if (vending) {
		/* pick random icon to display as vending sound plays */
		randNum = randIcon(randNum, categories.length);
		icon.src = 'Images/Icons/' + 
			categories[randNum][2][0];
	
		/* repeat vending sound */
		if (soundEnabled) {
			playSound('Vend');
		}
		else {
			setTimeout('VendSoundFinished()', 205);
		}
	}
}

function setFinalRestaurantIcon()
{
	var previousPicked = (pickedRestaurant) ? pickedRestaurant.name : null;
	var randomRestaurantIdx = -1;
	
	if (vending) {
		/* pseudo-random pick from restaurants[] */
		if (restaurantPool.length == 1) {
			/* No need to pick random is only one diner to choose from */
			pickedRestaurant = restaurantPool[0];
		}
		else {
			var i = 0;
			
			// give it 5 chances to pick a different name
			// don't want to loop forever here...
			do {
				randomRestaurantIdx = randRestaurant(randomRestaurantIdx, restaurantPool.length);
				pickedRestaurant = restaurantPool[randomRestaurantIdx];
			} while (i++ <=5 && previousPicked == pickedRestaurant.name);
		}
		
		stopSound();
		playSound('Select');
		
		/* fade in diner bar text */
		setRestaurantBarText(
			pickedRestaurant.name,
			pickedRestaurant.address,
			pickedRestaurant.tel,
			pickedRestaurant.fax,
			pickedRestaurant.rating,
			true, 1500);
			
		/* setup icon, animate if multiple pngs exist */
		setTimeout('setIcon()', 50);
		setTimeout('vending = false;', 100);
	}
}

function fadeRestaurantBar(animation, current, start, finish)
{
	restaurantBar.style.opacity = current;
	setRestaurantInfoOpacity(current);
}

function animateRestaurantIcon()
{
	var icons = categories[pickedRestaurant.category][2];
	var i = animateIndex;
		
	/* reset index if went pass last array element */
	if (++animateIndex == icons.length) {
		animateIndex = 0;
	}

	/* set icon to next in diner types array */	
	icon.src = 'Images/Icons/' + icons[i];
}

function playSound(sound)
{
	if (soundEnabled == true && window.DOMPluginController) {
		DOMPluginController.playSound(sound);
	}
}

function stopSound()
{
	if (soundEnabled == true && window.DOMPluginController) {
		DOMPluginController.stopSounds();
	}
}

function seed()
{
	if (window.DOMPluginController) {
		DOMPluginController.seed();
	}
}

function randIcon(prev, max)
{
	if (window.DOMPluginController) {
		return DOMPluginController.randIcon(prev, max);
	}

	return 0;
}

function randRestaurant(prev, max)
{
	if (window.DOMPluginController) {
		return DOMPluginController.randRestaurant(prev, max);
	}

	return 0;
}

function setIcon()
{
	/* 
	 * disable plate and animation until we determine
	 * if we have enough data/state to enable them
	 */
	dinnerPlate.setEnabled(false);
	stopIconTimer();
	
	// in case for some reason pickedRestaurant is set out-of-range
	//if (pickedRestaurant >= restaurantPool.length) {
	//	pickedRestaurant = -1;
	//}
	
	if (pickedRestaurant == null) {
		icon.src = 'Images/Icons/Iconfactory.png';

		/* reset status bar text */
		restaurantBar.style.opacity = 1;
		setRestaurantInfoOpacity(0);
		
		if (restaurantPool.length < 1) {
			setRestaurantBarText(noPickAvailable, '', '', '', 0, false, 0);
			setRestaurantInfoOpacity(0);
		}
		else if (restaurants.length > 0) {
			setRestaurantBarText(defaultRestaurantBarText, '', '', '', 0, false, 0);
			setRestaurantInfoOpacity(0);
		}
		else {
			setRestaurantBarText(emptyRestaurantBarText, '', '', '', 0, false, 0);
			setRestaurantInfoOpacity(0);
		}
	}
	else {
		/* display icon */
		icon.src = 'Images/Icons/' + categories[pickedRestaurant.category][2][0];
		if (categories[pickedRestaurant.category][2].length > 1) {
			startIconTimer();
		}
	}
	
	/* if eateries available, enable diner plate */
	if (restaurantPool && restaurantPool.length > 0) {
		dinnerPlate.setEnabled(true);
	}
}

function startIconTimer()
{
	animateIndex = 1;
	animateTimer = setInterval('animateRestaurantIcon()', categories[pickedRestaurant.category][3]);
}


function stopIconTimer()
{
	if (animateTimer != null) {
		clearInterval(animateTimer);
		animateTimer = null;
	}
}

function setRestaurantBarText(name, address, tel, fax, rating, fade, delay, hideInfo)
{
	restaurantBar.innerText = name;
	restaurantInfoAddress.innerText = address;
	restaurantInfoTel.innerText = tel;
	restaurantInfoFax.innerText = fax;
	
	restaurantInfoRating.innerHTML = '';
	for (var i = 0; i < rating; i++) {
		restaurantInfoRating.innerHTML += '<img src="Images/star_front.png" alt="">';
	}
	
	/* if we overflowed, scroll diner name instead, 167 number hard coded
	 * because Safari/Webkit lacks element.getComputedStyle() javascript */
	if (restaurantBar.scrollWidth > 167) {
		restaurantBar.innerHTML = 
			"<marquee id=\"dbmarquee\" behavior=\"scroll\" scrolldelay=\"175\" width=\"167\">" +
			restaurantBar.innerText + "</marquee>";
	}
	
	if (faderAnimator) {
		faderAnimator.stop();
		faderAnimator = null;
	}
	
	if (fade) {
		faderAnimator = new AppleAnimator(delay, 50, 0.0, 1.0, fadeRestaurantBar);
		faderAnimator.start();
	}
	else {
		restaurantBar.style.opacity = 1;
		setRestaurantInfoOpacity(1);
	}
}

function setRestaurantInfoOpacity(opacity, showMapIcon, showWebIcon)
{
	restaurantInfoMapLink.style.opacity = opacity;
	restaurantInfoWebLink.style.opacity = opacity;
	restaurantInfoAddress.style.opacity = opacity;
	restaurantInfoTelLabel.style.opacity = opacity;
	restaurantInfoTel.style.opacity = opacity;
	restaurantInfoFaxLabel.style.opacity = opacity;
	restaurantInfoFax.style.opacity = opacity;
	restaurantInfoRatingLabel.style.opacity = opacity;
	restaurantInfoRating.style.opacity = opacity;

	if (opacity == null || opacity == 0) {
		restaurantInfoMapLink.style.display = 'none';
		restaurantInfoWebLink.style.display = 'none';
		restaurantInfoAddress.style.display = 'none';
		restaurantInfoTelLabel.style.display = 'none';
		restaurantInfoTel.style.display = 'none';
		restaurantInfoFaxLabel.style.display = 'none';
		restaurantInfoFax.style.display = 'none';
		restaurantInfoRatingLabel.style.display = 'none';
		restaurantInfoRating.style.display = 'none';
	}
	else {
		if (pickedRestaurant != null) {
			if (!empty(pickedRestaurant.address)) {
				restaurantInfoMapLink.style.display = 'block';
			}
			if (!empty(pickedRestaurant.web)) {
				restaurantInfoWebLink.style.display = 'block';
			}
		}
		restaurantInfoAddress.style.display = 'block';
		restaurantInfoTelLabel.style.display = 'block';
		restaurantInfoTel.style.display = 'block';
		restaurantInfoFaxLabel.style.display = 'block';
		restaurantInfoFax.style.display = 'block';
		restaurantInfoRatingLabel.style.display = 'block';
		restaurantInfoRating.style.display = 'block';
	}
}

function startRestaurantBarMarquee()
{
	var mq = document.getElementById('dbmarquee');
	
	if (mq) {
		mq.start();
	}
}

function stopRestaurantBarMarquee()
{
	var mq = document.getElementById('dbmarquee');
	
	if (mq) {
		mq.stop();
	}
}

function startAnimations()
{
	setIcon();
	
	if (pickedRestaurant) {
		setRestaurantBarText(
			pickedRestaurant.name, 
			pickedRestaurant.address,
			pickedRestaurant.tel,
			pickedRestaurant.fax,
			pickedRestaurant.rating,
			false, 0);
	}
	
	startRestaurantBarMarquee();
}

function stopAnimations()
{
	stopRestaurantBarMarquee();
	stopIconTimer();
}

function load()
{
	initDineomatic();
}

function remove()
{
}

function hide()
{
	widgetHidden = true;
	vending = false;
	stopAnimations();
}

function show()
{
	widgetHidden = false;
	startAnimations();
}

function showBack(event)
{
	flipWidth = document.width;
	flipHeight = document.height;
	
	// resize canvas to fit back image
	window.resizeTo(BACK_WIDTH, BACK_HEIGHT);
	
	stopSound();
	stopAnimations();
	
	resetPrefsChanged();
	vending = false;
	
	var front = document.getElementById('front');
	var back = document.getElementById('back');
	
	if (window.widget) {
		widget.prepareForTransition('ToBack');
	}
	
	front.style.display = 'none';
	back.style.display = 'block';
	
	if (window.widget) {
		setTimeout('widget.performTransition();', 0);
	}
	
	restaurantReload();
	categoryReload();
}

function showFront(event)
{
	var front = document.getElementById('front');
	var back = document.getElementById('back');

	if (window.widget) {
		widget.prepareForTransition('ToFront');
	}

	front.style.display = 'block';
	back.style.display = 'none';
	
	if (window.widget) {
		setTimeout('widget.performTransition();', 0);
		
		/* if any changes made, write them out now */
		if (prefsChanged['sound']) {
			//alert('soundEnabled: ' + soundEnabled);
			widget.setPreferenceForKey(soundEnabled, 'soundEnabled');
		}
		
		if (prefsChanged['favorHigherRated']) {
			//alert('favorHigherRated: ' + favorHigherRated);
			widget.setPreferenceForKey(favorHigherRated, 'favorHigherRated');
		}
		
		if (prefsChanged['categories']) {
			//alert('       catJS: ' + createCategoryJSString());
			widget.setPreferenceForKey(createCategoryJSString(), 'categories');
		}
		
		if (prefsChanged['restaurants']) {
			//alert('      restJS: ' + createRestaurantsJSString());
			widget.setPreferenceForKey(createRestaurantsJSString(), 'restaurants');
			widget.setPreferenceForKey(null, 'dinerData');
		}
		
		if (prefsChanged['resetIcon']) {
			//alert('reseting front icon');
			pickedRestaurant = null;
		}
	}
	
	restaurantCreatePool();
	
	resetPrefsChanged();
	startAnimations();
	
	window.resizeTo(flipWidth, flipHeight);
}

function onShowRestaurantTab(event)
{
	restaurantReload();
	restaurantInfoReloadCategoryPopup();
}

function onShowCategoryTab(event)
{
	categoryListView.refresh();
	categoryListView.revealSelected();
}

function onShowAboutTab(event)
{
}

function resetPrefsChanged()
{
	for (var pref in prefsChanged) {
		prefsChanged[pref] = false;
	}
}

function createCategoryJSString()
{
	var catArray = new Array();
	
	for (var i = 0; i < categories.length; i++) {
		var data = categories[i];
		var iconData = new Array();
			
		for (var j = 0; j < data[2].length; j++) {
			iconData[iconData.length] = formatStringForPreferences(data[2][j]);
		}
		// should always be at least one icon...
		iconData = '[' + iconData.join(',') + ']';
		
		// [Name, Enabled, Icon Array, Animation Timeout, isDefaultCategory]
		// ['American', true, ['American.png', 'American2.png'], 1125, true]
		
		catArray[catArray.length] = '['
			+ formatStringForPreferences(data[0]) + ','
			+ data[1] + ','
			+ iconData + ','
			+ data[3] + ','
			+ data[4]
			+ ']';
	}
	
	if (catArray.length == 0) {
		return null;
	}
	
	return '[' + catArray.join(',') + ']';
}

 
function createRestaurantsJSString()
{
	var restArray = new Array();
	
	for (var i = 0; i < restaurants.length; i++) {
		var data = restaurants[i];

		// make sure the name does not have any single quotes in it
		restArray[restArray.length] = '{'
			+ 'name:' + formatStringForPreferences(data.name) + ','
			+ 'enabled:' + data.enabled + ','
			+ 'category:' + data.category + ','
			+ 'address:' + formatStringForPreferences(data.address) + ','
			+ 'tel:' + formatStringForPreferences(data.tel) + ','
			+ 'fax:' + formatStringForPreferences(data.fax) + ','
			+ 'web:' + formatStringForPreferences(data.web) + ','
			+ 'price:' + data.price + ','
			+ 'rating:' + data.rating
			+ '}';
	}
	
	if (restArray.length == 0) {
		return null;
	}
	
	return '[' + restArray.join(',') + ']';
}

function openURL(url) {
	if (window.widget) {
		if (url.substring(0,7) != 'http://' && url.substring(0,8) != 'https://') {
			url = 'http://' + url;
		}
		widget.openURL(url);
	}
}

function trim(str)
{
	var lstr = str;
	lstr = lstr.replace(/^\s+/g, '');
	return lstr.replace(/\s+$/g, '');
}

function empty(str)
{
	if (str == null || str.length == 0 || trim(str + '').length == 0) {
		return true;
	}
	
	return false;
}

function lowercase(str)
{
	if (empty(str)) {
		return '';
	}
	
	return str.toLowerCase();
}

function isnull(obj, ret)
{
	if (obj === undefined || obj == null) {
		return ret;
	}
	
	return obj;
}

/* Bug in both SubEthaEdit and Dashcode: javascript replace causes
 * syntax highlighting to mess up for remainder of the file 
 * 
 * So putting this helper function at the end of the file...
 */

function formatStringForPreferences(str)
{
	if (empty(str)) {
		return null;
	}
	
	str = str.replace(/\t/g, "\\t");
	str = str.replace(/\n/g, "\\n");
	str = "'" + str.replace(/\'/g, "\\'") + "'";
	
	return str;
}
